//
//  DrawingView.swift
//  CoreGraphicsPlayground
//
//  Created by Holger Hinzberg on 23.01.16.
//  Copyright © 2016 Holger Hinzberg. All rights reserved.
//

import UIKit

class DrawingView: UIView
{
    override init(frame: CGRect)
    {
        super.init(frame: frame)
        self.backgroundColor = UIColor.whiteColor()
    }

    required init?(coder aDecoder: NSCoder)
    {
        super.init(coder: aDecoder)
    }

    override func drawRect(rect: CGRect)
    {
        let context = UIGraphicsGetCurrentContext()
        CGContextSaveGState(context)
        // Den Pfad erzeugen
        self.createPath(context!)
        // Die Zeichenfläche auf den Pfad begrenzen
        CGContextClip(context)
        // Den Farbverlauf zeichnen
        self.fillWithGradient(context!)
        CGContextRestoreGState(context)
        
        CGContextSaveGState(context)
        CGContextSetStrokeColorWithColor(
        context, UIColor.redColor().CGColor)
         CGContextSetLineWidth(context, 3)
        self.createPath(context!)
        CGContextStrokePath(context)
        CGContextRestoreGState(context)
    }
    
    /*
    override func drawRect(rect: CGRect)
    {
        let context = UIGraphicsGetCurrentContext()
        CGContextSaveGState(context)
        
        CGContextSetStrokeColorWithColor(
            context, UIColor.redColor().CGColor)
        CGContextSetFillColorWithColor(
            context, UIColor.greenColor().CGColor)
        CGContextSetLineWidth(context, 3)
        
        self.createPath(context!)
        CGContextFillPath(context)
        
        self.createPath(context!)
        CGContextStrokePath(context)
        
        CGContextRestoreGState(context)
    }
*/
    
    func createPath(context:CGContextRef)
    {
        CGContextBeginPath(context)
        CGContextMoveToPoint(context, 50, 50)
        CGContextAddLineToPoint(context, 200, 50)
        CGContextAddQuadCurveToPoint(context,
            160, 125, 200, 200)
        CGContextAddLineToPoint(context, 50, 200)
        CGContextAddQuadCurveToPoint(context,
            140, 125, 50, 50)
    }
    
    func fillWithGradient(context:CGContextRef)
    {
        let colorSpace = CGColorSpaceCreateDeviceRGB()
        
        let components:[CGFloat] = [
            1.0, 0.0, 0.0, 1.0, // Rot
            0.0, 0.0, 1.0, 1.0 // Blau
        ]
        
        let locations:[CGFloat] = [0.0, 1.0]
     
        let gradient = CGGradientCreateWithColorComponents(colorSpace, components, locations, 2)
        
        let startPoint = CGPointMake(50, 50)
        let endPoint = CGPointMake(200, 200)
        
        CGContextDrawLinearGradient(context, gradient, startPoint, endPoint, [])
    }
    
    
    /*
    override func drawRect(rect: CGRect)
    {
        let context = UIGraphicsGetCurrentContext()
        CGContextSaveGState(context)
        
        CGContextSetStrokeColorWithColor(
            context, UIColor.redColor().CGColor)
        CGContextSetLineWidth(context, 2)
        
        let halfWidth:CGFloat = self.bounds.size.width / 2
        let halfHeight:CGFloat = self.bounds.size.height / 2
        
        for var i:CGFloat = 0; i <= 30; i++
        {
            CGContextBeginPath(context)
            CGContextMoveToPoint(context, 0, halfHeight)
            CGContextAddQuadCurveToPoint(context, halfWidth,
                20 * i, self.bounds.size.width, halfHeight)
            CGContextStrokePath(context)
        }
        
        CGContextSetStrokeColorWithColor(
            context, UIColor.blueColor().CGColor)
        
        for var i:CGFloat = 0; i <= 30; i++
        {
            CGContextBeginPath(context)
            CGContextMoveToPoint(context, halfWidth, 0)
            CGContextAddCurveToPoint(context, 5 * i + halfWidth,
                halfWidth - 5 * i, 10 * i, 10 * i, halfWidth, self.bounds.size.height)
            CGContextStrokePath(context)
        }
        
        CGContextRestoreGState(context)
    }
    */
    
    /*
    override func drawRect(rect: CGRect)
    {
        let context = UIGraphicsGetCurrentContext()
        let colorSpace = CGColorSpaceCreateDeviceRGB()
        CGContextSaveGState(context)
    
        // Die einzelnen Farben für den Verlauf bestimmen
        let components:[CGFloat] = [
            1.0, 0.0, 0.0, 1.0, // Rot
            1.0, 1.0, 1.0, 1.0, // Weiß
            0.0, 0.0, 1.0, 1.0 // Blau
        ]
        
        // Die Verteilung der Farben innerhalb des Verlaufes
        let locations:[CGFloat] = [0.0, 0.5, 1.0]
        
        // Den Farbverlauf erstellen
        let gradient = CGGradientCreateWithColorComponents(colorSpace, components, locations, 3)
    
        let centerPoint = CGPointMake(self.bounds.size.width / 2, self.bounds.size.height / 2)
        let startRadius:CGFloat = 0.0
        let endRadius:CGFloat = self.bounds.size.width / 2 - 20
        
        let startCenterPoint = CGPointMake(30, 30);
        let endCenterPoint = CGPointMake(170, 220);
        
        CGContextDrawRadialGradient(context, gradient, startCenterPoint, startRadius, endCenterPoint , endRadius, [])
        
        //CGContextDrawRadialGradient(context, gradient, centerPoint, startRadius, centerPoint , endRadius, [])
        
        CGContextRestoreGState(context)
    }
    */
    
    /*
    override func drawRect(rect: CGRect)
    {
        let context = UIGraphicsGetCurrentContext()
        
        // Den RGB-Farbraum holen
        let colorSpace = CGColorSpaceCreateDeviceRGB()
        
        // Die einzelnen Farben für den Verlauf bestimmen
        let components:[CGFloat] = [
        1.0, 0.0, 0.0, 1.0, // Rot
        1.0, 1.0, 1.0, 1.0, // Weiß
        0.0, 0.0, 1.0, 1.0 // Blau
        ]
        
        // Die Verteilung der Farben innerhalb des Verlaufes
        let locations:[CGFloat] = [0.0, 0.5, 1.0]
        
        // Den Farbverlauf erstellen
        let gradient = CGGradientCreateWithColorComponents(colorSpace, components, locations, 3)
        
        // Den Start- und Endpunkt bestimmen
        // let startPoint = CGPointMake(0, 0)
        //let endPoint = CGPointMake(300, 440)
        
        CGContextSaveGState(context)
        
        // Ein Rechteck definieren
        let clipRect = CGRectMake(50.0, 30.0, 200, 300)
        // ... und die Zeichenfläche auf 
        // diesen Bereich beschneiden
        CGContextClipToRect(context, clipRect)
        
        let startPoint = CGPointMake(clipRect.origin.x, clipRect.origin.y)
        let endPoint = CGPointMake(clipRect.origin.x + clipRect.size.width, clipRect.origin.y + clipRect.size.height)
        
        // Hier wird gezeichnet!
        CGContextDrawLinearGradient(context, gradient, startPoint, endPoint, [])
        
        CGContextRestoreGState(context)
    }
    
    */
    
    /*
    override func drawRect(rect: CGRect)
    {
        let context = UIGraphicsGetCurrentContext()
        
        CGContextSetStrokeColorWithColor(
            context, UIColor.blueColor().CGColor)
        CGContextSetFillColorWithColor(
            context, UIColor.redColor().CGColor)
        CGContextSetLineWidth(context, 5)
        
        for var i:CGFloat = 0; i < 8; i++
        {
            // Ein rotes Rechteck mit einem
            // blauen Rand zeichnen
            let redRect = CGRectMake(110, 25 *  i * 2 + 10,
                30, 30)
            CGContextFillRect(context, redRect)
            CGContextStrokeRect(context, redRect)
            
            // Die aktuellen Context-Einstellungen speichern
            CGContextSaveGState(context)
            
            // Eine enue Füll - und Rahmenfarbe
            // sowie die Linienstärke setzen
            CGContextSetStrokeColorWithColor(
                context, UIColor.blackColor().CGColor)
            CGContextSetFillColorWithColor(
                context, UIColor.greenColor().CGColor)
            CGContextSetLineWidth(context, 1)
            
            let greenRect = CGRectMake(170, 25 *  i * 2 + 10,
                30, 30)
            CGContextFillRect(context, greenRect)
            CGContextStrokeRect(context, greenRect)
            
            // Deie vorherigen Context-Einstellungen
            // wiederherstellen
            CGContextRestoreGState(context)
        }
    }
    */
    
    /*
    override func drawRect(rect: CGRect)
    {
        let context = UIGraphicsGetCurrentContext()
        if let ct = context
        {
            self.drawEllipse(ct, size: self.bounds.size)
            self.drawRectangle(ct, size: self.bounds.size)
        }
    }
    */
    
    func drawEllipse(context:CGContextRef, size:CGSize)
    {
        let height = size.height
        let width = size.width
        
        // Die Linien- und Füllfarbe setzen
        CGContextSetStrokeColorWithColor(
            context, UIColor.blueColor().CGColor)
        CGContextSetFillColorWithColor(
            context, UIColor.greenColor().CGColor)

       // Die Linienstärke und -art setzen
       CGContextSetLineWidth(context, 15)
       let dashes:[CGFloat] = [5, 10]
       CGContextSetLineDash(context, 0, dashes, 2)
      
        // Die Größe des umgebenden Rechtecks berechnen
        let ellipseDiameter = width - 25
        let distanceLeft = (width - ellipseDiameter) / 2
        let distanceTop = (height - ellipseDiameter) / 2
        
        let borderRect = CGRectMake(distanceLeft, distanceTop,
            ellipseDiameter, ellipseDiameter)
        
        // Eine Ellipse (hier einen Kreis) zeichnen
        CGContextFillEllipseInRect(context, borderRect)
        CGContextStrokeEllipseInRect(context, borderRect)
    }

    func drawRectangle(context:CGContextRef, size:CGSize)
    {
        let height = size.height
        let width = size.width
        
        // Die Linien- und Füllfarbe setzen
        CGContextSetStrokeColorWithColor(
            context, UIColor.blackColor().CGColor)
        CGContextSetFillColorWithColor(
            context, UIColor.redColor().CGColor)
        
        // Die Linienstärke und -art setzen
        CGContextSetLineWidth(context, 2)
        let dashes:[CGFloat] = [1]
        CGContextSetLineDash(context, 0, dashes, 2)
        
        // Die Größe des umgebenden Rechtecks berechnen
        let rectangleWidth = width - 80
        let distanceLeft = (width - rectangleWidth) / 2
        let distanceTop = (height - rectangleWidth) / 2
        
        let borderRect = CGRectMake(distanceLeft, distanceTop,
            rectangleWidth, rectangleWidth)
        
        // Ein Rechteck zeichnen
        CGContextFillRect(context, borderRect)
        CGContextStrokeRect(context, borderRect)
    }
    
    /*
    override func drawRect(rect: CGRect)
    {
        let xOrigin = self.frame.origin.x
        let yOrigin = self.frame.origin.y
        
        print("Der X-Ursprung ist \(xOrigin)")
        print("Der Y-Ursprung ist \(yOrigin)")
        
        let height:CGFloat = self.bounds.size.height
        let width:CGFloat = self.bounds.size.width
        let context = UIGraphicsGetCurrentContext()
        
        CGContextSetStrokeColorWithColor(
            context, UIColor.blackColor().CGColor)
        
        // Eine horizontale Linie in der
        // Mitte des Views zeichnen
        CGContextBeginPath(context)
        CGContextMoveToPoint(context, 0, height / 2)
        CGContextAddLineToPoint(context, width, height / 2)
        CGContextStrokePath(context)
        
        // Eine horizontale Linie in der
        // Mitte des View zeichnen
        CGContextBeginPath(context)
        CGContextMoveToPoint(context, width / 2, 0)
        CGContextAddLineToPoint(context, width / 2 , height)
        CGContextStrokePath(context)
    }
    */
    
    /*
    override func drawRect(rect: CGRect)
    {
        let height:CGFloat = self.bounds.size.height
        let width:CGFloat = self.bounds.size.width
        
        print("Der View is \(height) Punkte hoch.")
        print("Der View is \(width) Punkte breit.")
        
        let context = UIGraphicsGetCurrentContext()
    
        // Die 1. Linie
        
        // Die Linienfarbe auf Blau setzen
        CGContextSetStrokeColorWithColor(
            context, UIColor.blueColor().CGColor)
        
        // Eine Linie von der oberen linken Ecke
        // in die untere rechte Ecke zeichnen
        CGContextBeginPath(context)
        CGContextMoveToPoint(context, 0, 0)
        CGContextAddLineToPoint(context, width, height)
        CGContextStrokePath(context)
        
        // Die 2. Linie
        
        // Die Linienstärke (Breite) setzen
        CGContextSetLineWidth(context, 5)
        
        // Die Linie soll gestrichelt sein
        let dashes:[CGFloat] = [10, 5]
        CGContextSetLineDash(context, 0, dashes, 2)
        
        // Die Linienfarbe auf Rot setzen
        CGContextSetStrokeColorWithColor(
            context, UIColor.redColor().CGColor)
        
        // Eine Linie von der unteren linken Ecke
        // in die obere rechte Ecke zeichnen
        CGContextBeginPath(context)
        CGContextMoveToPoint(context, 0, height)
        CGContextAddLineToPoint(context, width, 0)
        CGContextStrokePath(context)
    }
    */
    
/*
    override func drawRect(rect: CGRect)
    {
        // Den grafischen Context holen
        let context = UIGraphicsGetCurrentContext()
        CGContextSetFillColorWithColor(
            context, UIColor.redColor().CGColor)
        
        var rectangle = CGRectMake(0, 0, 200, 100)
        CGContextFillRect(context, rectangle)
        
        // Ein zweites rotes Rechteck
        rectangle = CGRectMake(30, 230, 200, 100)
        CGContextFillRect(context, rectangle)
        
        // Ein blaues Rechteck
        CGContextSetFillColorWithColor(
            context, UIColor.blueColor().CGColor)
        
        rectangle = CGRectMake(50, 50, 100, 260)
        CGContextFillRect(context, rectangle)
    }
*/
}
